/* 32-Bit CRC engine, from FUNZIP.C Version 3.83
   put in the public domain by Mark J.Adler.
   Minor modifications by Tillmann Steinbrecher			*/

#include "crc_tab.h"

unsigned long updcrc(unsigned char *s,unsigned long n)
	       /* pointer to bytes to pump through */
	       /* number of bytes in s[] */
/* Run a set of bytes through the crc shift register.  If s is a NULL
   pointer, then initialize the crc shift register contents instead.
   Return the current crc in either case. */
{
  register unsigned long c;       /* temporary variable */

  static unsigned long crc = 0xffffffffL; /* shift register contents */

  if (s == (unsigned char *)NULL)
    c = 0xffffffffL;
  else
  {
    c = crc;
    while (n--)
      c = crc_32_tab[((int)c ^ (*s++)) & 0xff] ^ (c >> 8);
  }
  crc = c;
  return c ^ 0xffffffffL;       /* (instead of ~c for 64-bit machines) */
}
