/*	TAR stream decompression engine Copyright (c) 1996 T. Steinbrecher */

#ifndef PROG_NAME
	#define	PROG_NAME	"untar-engine"
#endif

/* #define VERBOSE */

typedef struct {
  char name[100];
  char operm[8];
  char ouid[8];
  char ogid[8];
  char osize[12];
  char otime[12];
  char ocsum[8];
  char flags;
  char filler[355];
} TARHEADER;

  int outfile;
  long position=-1,size;
  long datapos=0;
  char dosname[100]="";
  char skip=0, answer=0, s_answer=0;
  struct ftime timedate;

int cdecl c_break(void){
	printf(PROG_NAME ": error - aborted, file may be corrupt.");
	error++;
	printf(PROG_NAME ": found %i errors\n",error);
	exit(2);
	return 0; /* Never reached ... */
	}

int ask(void){
	if(answer=='a'||answer=='A') return 1;
	if(answer=='s'||answer=='S') { printf(" skipped"); return 0; }
	for(;;){
		printf(" [YNASRQ] Y\b");
		answer=getche();
		if(answer=='y'||answer=='Y'||answer==13) return 1;
		if(answer=='n'||answer=='N'||answer==27) return 0;
		if(answer=='a'||answer=='A') return 1;
		if(answer=='r'||answer=='R') return 2;
		if(answer=='s'||answer=='S') return 0;
		if(answer=='q'||answer=='Q') c_break();
		printf("\nYes, No, Always, Skip, Rename or Quit\a");
	       }
	  }

int istarheader(unsigned char *hdr,long csum,char askflag){
	long newsum=0;
	int cnt;
	for(cnt=0;cnt<=147;cnt++) newsum+=*(hdr+cnt);
	for(cnt=156;cnt<512;cnt++) newsum+=*(hdr+cnt);
	newsum+=256;
#ifdef VERBOSE
	printf("newsum=%li csum=%li\n",newsum,csum); 
#endif
	if(newsum==csum) return 1;
        else {
	  if(askflag){
	        if(s_answer=='a'||s_answer=='A'||s_answer==13) return 0;
                printf(PROG_NAME ": warning - possibly invalid tar archive, skip to next block");
	for(;;){
		printf(" (Y/N/A/Q) A\b");
                s_answer=getche();
		if(s_answer=='y'||s_answer=='Y') return 0;
		if(s_answer=='n'||s_answer=='N') return 1;
		if(s_answer=='a'||s_answer=='A'||s_answer==13) {
			printf(PROG_NAME ": searching for valid tar header ...");
			return 0;
		      }	
		if(s_answer=='q'||s_answer=='Q') c_break();
                printf("\nYes, No, Always or Quit\a");
	       }
	     } else return 0;
           }     
	}

int createnewdir(char name[]){
	char stat;
	if (name[strlen(name)-1] == '/') name[strlen(name)-1] = 0;
	printf(" Creating directory: %s ", name);
	stat = mkdir(name
#ifdef GNUDOS
	,0
#endif
	);
	if (stat && (errno==EACCES))
	{
	  printf(PROG_NAME ": warning - duplicate directory name\n");
	  stat=0;
	}

	if (stat) {
	  printf(PROG_NAME ": error - unable to create directory\n");
	  error++;
	  return -1;
		}
	return 0;
    }

int create_path(char *path){
	char create[128],pos;
	printf("- missing directory!\n Auto-creating directories for %s\n",path);
        for(pos=0;pos<=(strrchr(path,'/')-path);pos++){
          if(path[pos]=='/') { 
		create[pos]=0;
		createnewdir(create);
		create[pos]='/';
		printf("OK\n");
			   }
	  else create[pos]=path[pos];
        }
	printf(" Directories created, extracting %s ",path);
	return 0;
	}


int openfile(char oldname[],char name[]) {
      printf(" Extracting %s ",oldname);
      if(strcmp(oldname,name))printf("to %s ",name);
      outfile = open(name, O_WRONLY|O_BINARY|O_CREAT|O_EXCL, S_IWRITE|S_IREAD);
      if (outfile < 0 && errno==ENOENT) {
		create_path(name);
		outfile = open(name, O_WRONLY|O_BINARY|O_CREAT|O_EXCL, S_IWRITE|S_IREAD);
	      }
      if (outfile < 0 && errno==EEXIST){
	  printf(PROG_NAME ": file %s exists - overwrite",name);

      switch(ask()){
	  case 1:
		outfile=open(name, O_WRONLY|O_BINARY|O_TRUNC, S_IWRITE|S_IREAD);
		printf("\n Overwritig %s ",name);
		break;
	  case 2:
		printf("\nEnter new name:");
		gets(name);
		return(openfile(oldname,name)); /* Recursive retry */
	  default:
		printf("\n Skipping %s ",name);
		return 1;
	     }

	  }
	 if(outfile<0){
		printf(PROG_NAME ": error - can't create file, skipping %s ",dosname);
		error++;
		return 1;
	    }
	return 0;
	}


int untarstream(unsigned char data[], unsigned long datasize)
{
  unsigned long dsize=0;
  TARHEADER header;
  long perm, uid, gid, time, csum;
  struct time filetime;
  struct date filedate;

  datapos=0;
  for(;;){
   if(position==-1) {
do{
    memcpy( &header, data+datapos,512);
    if (header.name[0] == 0) break; 
    sscanf(header.operm, "%lo", &perm);
    sscanf(header.ouid, "%lo", &uid);
    sscanf(header.ogid, "%lo", &gid);
    sscanf(header.ocsum, "%lo", &csum);
    sscanf(header.osize, "%lo", &size);
    sscanf(header.otime, "%lo", &time);
#ifdef VERBOSE
    printf("otime= %s ocsum= %s ",header.otime,header.ocsum);
#endif
    datapos+=512;
    if(datapos>datasize) return 0;
}while(!istarheader((char*)&header,csum,1));
    if (header.name[0] == 0) break; 
    position=0;
    skip=0;
#ifdef _32BIT_VERSION_
    strcpy(dosname,header.name);
#else	
    dos_pathname(header.name,dosname);
#endif

/* Adjust the time so that is set correctly

   uuuh this is a dirty workaround for a bug which
   I couldn't fix otherwise.

   Can you do any better? */

#ifdef TIME_BUG_WORKAROUND

        #ifdef _OS2_VERSION_                            /* OS/2 Version */
                if(timezone==18000) time -= 10800;
                else time= time - 25200 + timezone;

        #elif defined (_32BIT_VERSION_)                           /* Win32 version */
           time = time - 36000 + timezone;
	#endif

        #ifndef _32BIT_VERSION_                         /* DOS version */
                if(timezone==18000) time -= 10800;
                else time= time - 25200 + timezone;
        #endif

#endif

    unixtodos(time,&filedate,&filetime);
    timedate.ft_tsec=filetime.ti_sec;
    timedate.ft_min=filetime.ti_min;
    timedate.ft_hour=filetime.ti_hour;
    timedate.ft_day=filedate.da_day;
    timedate.ft_month=filedate.da_mon;
    timedate.ft_year=filedate.da_year-1980;

    if (header.flags=='5'||header.name[strlen(header.name)-1]=='/')
    {
       if (header.name[strlen(header.name)-1] == '/')
	header.name[strlen(header.name)-1] = 0;
       createnewdir(dosname);
       skip=1; /* Directory ??? */
	}
    else    { skip=openfile(header.name,dosname); }
}

   if ((size-position) <= (datasize-datapos)){
	dsize = size-position;

       }

   else dsize = (datasize-datapos);
   if(!skip){
    if (write(outfile,data+datapos,dsize)<dsize){
	printf(PROG_NAME ": error - can't write file, disk full?");
	error++;
	c_break();
    }
   }
   position += dsize;
   datapos += dsize;
   if(size==position) {
	if(!skip){
		setftime(outfile,&timedate);
		close(outfile);
		}
	position=-1;
	if(datapos % 512) datapos=( (datapos / 512) + 1) * 512;
	printf("OK   \n");
       }
   if(datasize==datapos)
	 return 0;  /* Finished processing buffer */
       }
return 0;
}

